//
//  Convertisseur2FlipsideViewController.m
//  Convertisseur2
//
//  Created by Jean-Pierre IMBERT on 28/01/13.
//  Copyright (c) 2013 SkwalSoft. All rights reserved.
//

#import "Convertisseur2FlipsideViewController.h"

@interface Convertisseur2FlipsideViewController ()
- (BOOL)rateFieldIsValid;
- (void)returnToMainView;
@end

@implementation Convertisseur2FlipsideViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    self.rateFieldDelegate.value = self.rate;
    self.rateField.text = [NSString localizedStringWithFormat:
                      @"%.5f",self.rate];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Actions

- (IBAction)done:(id)sender
{
    if ( self.rateFieldIsValid ) {
        [self returnToMainView];
    } else {
        UIActionSheet *sheet = [[UIActionSheet alloc] initWithTitle:@"Le taux de conversion paraît incorrect"
                                                           delegate:self
                                                  cancelButtonTitle:@"Éditer le taux à nouveau"
                                             destructiveButtonTitle:@"Le taux est correct"
                                                  otherButtonTitles: nil];
        [sheet showInView:self.view];
    }
}

- (void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if (buttonIndex == actionSheet.cancelButtonIndex) {
        [self.rateField becomeFirstResponder];
    } else if (buttonIndex == actionSheet.destructiveButtonIndex) {
        [self returnToMainView];
    }
}

- (void)returnToMainView
{
    self.rate = self.rateFieldDelegate.value;
    [self.delegate flipsideViewControllerDidFinish:self];
}

- (BOOL)rateFieldIsValid
{
    float rate = self.rateFieldDelegate.value;
    return (rate >= 0.5) && (rate <= 2.);
}

@end
