//
//  Convertisseur2FirstViewController.m
//  Convertisseur2
//
//  Created by Jean-Pierre IMBERT on 02/02/13.
//  Copyright (c) 2013 SkwalSoft. All rights reserved.
//

#import "Convertisseur2FirstViewController.h"
#import "Convertisseur2SecondViewController.h"

@interface Convertisseur2FirstViewController ()

@end

@implementation Convertisseur2FirstViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    self.tabBarController.delegate = self;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)changeValue:(UITextField *)textField {
    NSString * currencyRead;
    currencyRead = textField.accessibilityLabel;
    if ([currencyRead isEqualToString:@"euro"]) {
        self.convertisseur.euro = self.euroFieldDelegate.value;
        self.dollarField.text =
        [self.convertisseur localizedStringForKey:@"dollar"];
    } else {
        self.convertisseur.dollar = self.dollarFieldDelegate.value;
        self.euroField.text =
        [self.convertisseur localizedStringForKey:@"euro"];
    }
}

- (IBAction)hideKeyboard:(UITapGestureRecognizer *)sender {
    [self.euroField resignFirstResponder];
    [self.dollarField resignFirstResponder];
}

- (void) tabBarController:(UITabBarController *) tabBarController
  didSelectViewController:(UIViewController *)viewController {
    if (viewController==self) {
        self.dollarField.text =
        [self.convertisseur localizedStringForKey:@"dollar"];
        self.euroField.text =
        [self.convertisseur localizedStringForKey:@"euro"];
    } else {
        [(Convertisseur2SecondViewController *)viewController
                setRate:self.convertisseur.dollarsPourUnEuro];
    }
}

- (BOOL) tabBarController:(UITabBarController *)tabBarController shouldSelectViewController:(UIViewController *)viewController {
    BOOL returnValue = YES;
    if (viewController==self) {
        Convertisseur2SecondViewController * secondController = (Convertisseur2SecondViewController *)tabBarController.selectedViewController;
        if ([secondController rateFieldIsValid]) {
            self.convertisseur.dollarsPourUnEuro = secondController.rate;
        } else {
            UIAlertView *alert = [[UIAlertView alloc]
                                  initWithTitle:@"Taux incorrect" message:
                                  @"Le taux de conversion doit être compris entre 0,5 et 2"
                                  delegate:nil
                                  cancelButtonTitle:@"OK"
                                  otherButtonTitles:nil];
            [alert show];
            returnValue = NO;
        }
    }
    return returnValue;
}

@end
