//
//  Convertisseur.m
//  Convertisseur1
//
//  Created by Jean-Pierre IMBERT on 17/01/13.
//  Copyright (c) 2013 SkwalSoft. All rights reserved.
//

#import "Convertisseur.h"

@implementation Convertisseur

-(id) init {
    if (self = [super init]) {
        self.dollarsPourUnEuro = 1.308;
    }
    return self;
}

- (float) dollar {
    return self.euro * self.dollarsPourUnEuro;
}

- (void) setDollar:(float)dollar {
    self.euro = dollar / self.dollarsPourUnEuro;
}

- (NSString *) localizedStringForKey:(NSString *)key {
    return [NSString localizedStringWithFormat:
            @"%.2f",[[self valueForKey:key] floatValue]];
}

- (BOOL)readFromFile:(NSString *)path{
    NSDictionary * dict = [NSDictionary
                           dictionaryWithContentsOfFile:path];
    if (dict) {
        self.euro = [dict[@"euro"] floatValue];
        self.dollarsPourUnEuro = [dict[@"dollarsPourUnEuro"] floatValue];
    }
    return (dict != nil);
}
- (BOOL)writeToFile:(NSString *)path atomically:(BOOL)flag{
    NSDictionary *dict = @{@"euro":@(self.euro),
                           @"dollarsPourUnEuro":@(self.dollarsPourUnEuro)};
    return [dict writeToFile:path atomically:flag];
}

@end