//
//  Ball.h
//  Billard1
//
//  Created by Jean-Pierre IMBERT on 05/01/10.
//  Copyright 2010 JPI-Conseil. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AVFoundation/AVFoundation.h>

@protocol BallDelegate;

@interface Ball : NSObject {
	BOOL stop;
}

@property(weak, nonatomic) IBOutlet UIImageView *ballView;
@property(assign, nonatomic, readonly) CGSize size;
@property(assign, nonatomic, readonly) CGPoint center;
@property(weak, nonatomic) IBOutlet id <BallDelegate,NSObject> delegate;
@property(assign, nonatomic) CGFloat moveX;
@property(assign, nonatomic) CGFloat moveY;
@property(assign, nonatomic) CGRect tableRect;
		  
- (IBAction) start;
- (IBAction) stop;
- (void)moveBall;
+ (void)shockNoise;

@end

@protocol BallDelegate
- (CGRect) tableRect;
@optional
- (void) didStart:(Ball*)aBall;
- (void) didStop:(Ball*)aBall;
- (void) didMove:(Ball*)aBall;
@end