//
//  BillardViewController.m
//  Billard
//
//  Created by Jean-Pierre IMBERT on 18/02/13.
//  Copyright (c) 2013 SkwalSoft. All rights reserved.
//

#import "BillardViewController.h"

@interface BillardViewController ()

@end

@implementation BillardViewController

- (void)awakeFromNib
{
    self.redBall.delegate = self;
    self.violetBall.delegate = self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    [self.redBall start];
    [self.violetBall start];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - BallDelegate methods

- (CGRect)tableRect{
	return self.view.bounds;
}

- (void)didMove:(Ball *)aBall{
	CGRect rect1 = CGRectMake(self.redBall.center.x-self.redBall.size.width, self.redBall.center.y-self.redBall.size.height, self.redBall.size.width, self.redBall.size.height);
	CGRect rect2 = CGRectMake(self.violetBall.center.x-self.violetBall.size.width, self.violetBall.center.y-self.violetBall.size.height, self.violetBall.size.width, self.violetBall.size.height);
	if (CGRectIntersectsRect(rect1, rect2)) {
		CGPoint center1 = self.redBall.center;
		CGPoint center2 = self.violetBall.center;
		
		// Calcul de la base orthonormée (n,g)
		// n est perpendiculaire au plan de collision, g est tangent
		double nx = (center2.x - center1.x);
		double ny = (center2.y - center1.y);
		double norm = sqrt(nx*nx+ny*ny);
		if (norm < rect1.size.width) {
			nx = nx / norm;
			ny = ny / norm;
			double gx = -ny;
			double gy = nx;
			
			// Calcul des vitesses dans cette base
			double v1n = nx*self.redBall.moveX + ny*self.redBall.moveY;
			double v1g = gx*self.redBall.moveX + gy*self.redBall.moveY;
			double v2n = nx*self.violetBall.moveX + ny*self.violetBall.moveY;
			double v2g = gx*self.violetBall.moveX + gy*self.violetBall.moveY;
			
			// Permute les coordonnées n et conserve la vitesse tangentielle
			// Exécute la transformation inverse (base orthonormée => matrice transposée)
			self.redBall.moveX = nx*v2n +  gx*v1g;
			self.redBall.moveY = ny*v2n +  gy*v1g;
			self.violetBall.moveX = nx*v1n +  gx*v2g;
			self.violetBall.moveY = ny*v1n +  gy*v2g;
			[Ball shockNoise];
		}
	}
}

@end
