//
//  PinchView.m
//  Pinch
//
//  Created by Jean-Pierre IMBERT on 20/02/13.
//  Copyright (c) 2013 SkwalSoft. All rights reserved.
//

#import "PinchView.h"

@implementation PinchView

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
    }
    return self;
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
}
*/

- (void)touchesBegan:(NSSet *)touches
           withEvent:(UIEvent *)event {
}
- (void)touchesMoved:(NSSet *)touches
           withEvent:(UIEvent *)event {
    if ([[event touchesForView:self] count]==2) {
        // 2 doigts sont posés sur l'écran
        NSArray *t=[[event touchesForView:self] allObjects];
        // t1 et t2 sont les deux touches sur l'écran
        UITouch *t1 = [t objectAtIndex:0];
        UITouch *t2 = [t objectAtIndex:1];
        // calcul de la distance précédente
        CGPoint p1 = [t1 previousLocationInView:self];
        CGPoint p2 = [t2 previousLocationInView:self];
        CGFloat previousDistance =
        sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
        // calcul de la distance actuelle
        p1 = [t1 locationInView:self];
        p2 = [t2 locationInView:self];
        CGFloat currentDistance =
        sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
        // transmission du ratio au délégué
        [self.delegate pinchPerformed:
         currentDistance/previousDistance];
    }
}
- (void)touchesEnded:(NSSet *)touches
           withEvent:(UIEvent *)event {
}
- (void)touchesCancelled:(NSSet *)touches
               withEvent:(UIEvent *)event {
}

@end
