//
//  LendObjectViewController.m
//  Emprunts2
//
//  Created by Jean-Pierre IMBERT on 16/02/13.
//  Copyright (c) 2013 SkwalSoft. All rights reserved.
//

#import "LendObjectViewController.h"

@interface LendObjectViewController ()

@end

@implementation LendObjectViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    if ([UIImagePickerController isSourceTypeAvailable:
         UIImagePickerControllerSourceTypeCamera]){
        [self.pictureButton setTitle:@"Prendre une photo"
                       forState:UIControlStateNormal];
    } else if ([UIImagePickerController isSourceTypeAvailable:
         UIImagePickerControllerSourceTypePhotoLibrary]){
        [self.pictureButton setTitle:@"Choisir une photo"
                       forState:UIControlStateNormal];
    } else {
        self.pictureButton.enabled = NO;
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (NSString *)objectName
{
    return self.objectNameField.text;
}

- (void)setObjectName:(NSString *)objectName
{
    if (self.view) self.objectNameField.text = objectName;
}

- (NSString *)borrowerName
{
    return self.borrowerNameField.text;
}

- (void)setBorrowerName:(NSString *)borrowerName
{
    if (self.view) self.borrowerNameField.text = borrowerName;
}

- (NSDate *)date
{
    return self.datePicker.date;
}

- (void)setDate:(NSDate *)date
{
    if (self.view) self.datePicker.date = date;
}

- (UIImage *)picture
{
    return self.imageView.image;
}

- (void)setPicture:(UIImage *)picture
{
    if (self.view) self.imageView.image = picture;
}

- (IBAction)doneEditing:(UITextField *)sender {
}

- (IBAction)takePicture:(UIButton *)sender {
    UIImagePickerController *picker = [[UIImagePickerController alloc] init];
    if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]){
        picker.sourceType = UIImagePickerControllerSourceTypeCamera;
    } else {
        picker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
    }
    picker.allowsEditing = YES;
    picker.delegate = self;
    [self presentViewController:picker animated:YES completion:NULL];
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info{
    self.picture = info[UIImagePickerControllerEditedImage];
    [self dismissViewControllerAnimated:YES completion:NULL];
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker {
    [self dismissViewControllerAnimated:YES completion:NULL];
}

@end
