//
//  CarteViewController.m
//  Carte
//
//  Created by Jean-Pierre IMBERT on 22/02/13.
//  Copyright (c) 2013 SkwalSoft. All rights reserved.
//

#import "CarteViewController.h"
#import "Annotation.h"

@interface CarteViewController ()

@end

@implementation CarteViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)mapView:(MKMapView *)mapView
regionDidChangeAnimated:(BOOL)animated{
    MKCoordinateRegion region = mapView.region;
    self.latitudeLabel.text = [NSString stringWithFormat:@"Lat : %g",
                          region.center.latitude];
    self.longitudeLabel.text = [NSString stringWithFormat:@"Lon : %g",
                           region.center.longitude];
    self.hauteurLabel.text = [NSString stringWithFormat:@"Haut : %g",
                         region.span.latitudeDelta];
    self.largeurLabel.text = [NSString stringWithFormat:@"Larg : %g",
                         region.span.longitudeDelta];
}

- (IBAction)defineZone:(id)sender {
    self.zone = self.carte.region;
    Annotation * annotation = [[Annotation alloc] init];
    annotation.coordinate = self.zone.center;
    annotation.title = @"Centre de la zone";
    [self.carte addAnnotation:annotation];
}

- (IBAction)retrieveZone:(id)sender {
    [self.carte setRegion:self.zone animated:YES];
}

- (IBAction)changeType:(UISegmentedControl *)sender {
    switch (sender.selectedSegmentIndex) {
        case 0:
            self.carte.mapType = MKMapTypeStandard;
            break;
            
        case 1:
            self.carte.mapType = MKMapTypeSatellite;
            break;
            
        case 2:
            self.carte.mapType = MKMapTypeHybrid;
            break;
            
        default:
            break;
    }
}

@end
