//
//  VerticalView.m
//  Accelero
//
//  Created by Jean-Pierre IMBERT on 23/02/13.
//  Copyright (c) 2013 SkwalSoft. All rights reserved.
//

#import "VerticalView.h"

@interface VerticalView ()
@property (assign,nonatomic) CGPoint origin;
@property (assign,nonatomic) CGPoint endPoint;
@property (assign,nonatomic) CGFloat scale;
@end

@implementation VerticalView

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
    }
    return self;
}

- (void) layoutSubviews
{
    CGFloat height = self.bounds.size.height;
    CGFloat width = self.bounds.size.width;
    if (height<2.*width)
        self.scale = height;
    else
        self.scale = width/2.;
    self.origin = CGPointMake(width/2.,0.);
}

- (void)setVertLine:(CGSize)line{
    _vertLine = line;
    if (([[UIDevice currentDevice] orientation] == UIDeviceOrientationLandscapeLeft)||
        ([[UIDevice currentDevice] orientation] == UIDeviceOrientationLandscapeRight)) {
        CGFloat width = line.height;
        CGFloat height = -line.width;
        line = CGSizeMake(width, height);
    }
    CGPoint newEndPoint;
    if (line.height<0) {
        newEndPoint.x = line.width*self.scale+self.origin.x;
        newEndPoint.y = -line.height*self.scale+self.origin.y;
    } else {
        newEndPoint.x = -line.width*self.scale+self.origin.x;
        newEndPoint.y = line.height*self.scale+self.origin.y;
    }
    self.endPoint = newEndPoint;
    [self setNeedsDisplay];
}

- (void)drawRect:(CGRect)rect
{
    CGContextRef context = UIGraphicsGetCurrentContext();
    CGContextSetRGBStrokeColor(context, 1., 0.5, 0., 1.0);
    CGContextSetLineWidth(context, 15.);
    CGContextSetLineCap(context, kCGLineCapRound);
    CGPoint segment[2] = {self.origin,self.endPoint};
    CGContextStrokeLineSegments(context, segment, 2);
}

@end
