//
//  PenduState.h
//  Pendu
//
//  Created by Jean-Pierre IMBERT on 26/02/13.
//  Copyright (c) 2013 SkwalSoft. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "PenduViewController.h"
#import "PenduModel.h"

#define VIEW [self viewController]
#define SET_STATE(state) [VIEW setCurrentState:[state class]];

#define MODEL [VIEW model]

@interface PenduState : NSObject

+ (void) setViewController:(PenduViewController *) viewController;
+ (PenduViewController *) viewController;

+ (void) startApp;
+ (void) startGame: (BOOL) asServer;
+ (void) connectionLost;
+ (void) sleep;
+ (void) keyStroked: (NSString *) letter;
+ (void) backspaceStroked;
+ (void) actionOK;
+ (void) receivedString: (NSString *) aString;
+ (void) gameOver;

@end
