//
//  PenduState.m
//  Pendu
//
//  Created by Jean-Pierre IMBERT on 26/02/13.
//  Copyright (c) 2013 SkwalSoft. All rights reserved.
//

#import "PenduState.h"
#import "PenduStateInitial.h"
#import "PenduStateWaitingForPlayer.h"

static __weak PenduViewController * viewController;

@implementation PenduState

+ (void) setViewController:(PenduViewController *) aViewController{
    viewController = aViewController ;
}
+ (PenduViewController *) viewController {
    return viewController ;
}

+ (void) startApp {
	NSLog(@"StartApp");
}

+ (void) startGame: (BOOL) asServer {
	NSLog(@"StartGame");
}

+ (void) connectionLost {
	NSLog(@"connectionLost");
	[VIEW presentWaitingForConnexionScreen];
	SET_STATE (PenduStateWaitingForPlayer) ;
}

+ (void) sleep {
	NSLog(@"sleep");
	[VIEW clearSession];
	SET_STATE (PenduStateInitial) ;
}

+ (void) keyStroked: (NSString *) letter {
	NSLog(@"Lettre %@ touchée",letter);
}

+ (void) backspaceStroked {
	NSLog(@"Retour arrière touché");
}

+ (void) actionOK {
	NSLog(@"actionOK");
}

+ (void) receivedString: (NSString *) aString {
	NSLog(@"receivedString %@",aString);
}

+ (void) gameOver {
	NSLog(@"gameOver");
}

@end
