//
//  PenduViewController.h
//  Pendu
//
//  Created by Jean-Pierre IMBERT on 26/02/13.
//  Copyright (c) 2013 SkwalSoft. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <GameKit/GameKit.h>
#import "PenduModel.h"

@interface PenduViewController : UIViewController <GKSessionDelegate>

@property (weak, nonatomic) IBOutlet UILabel *topLabel;
@property (weak, nonatomic) IBOutlet UIImageView *imageView;
@property (weak, nonatomic) IBOutlet UILabel *middleLabel;
@property (weak, nonatomic) IBOutlet UILabel *bottomLabel;
@property (weak, nonatomic) IBOutlet UIButton *button;
@property (weak, nonatomic) IBOutlet UIActivityIndicatorView *activityIndicator;
@property (weak, nonatomic) IBOutlet UIView *keyboardView;
@property (strong,nonatomic) GKSession * session;
@property (strong,nonatomic) NSString * connectedPeer;
@property (assign,nonatomic) Class currentState;
@property (strong, nonatomic) IBOutlet PenduModel *model;
@property (assign,nonatomic) BOOL buttonEnabled;
@property (assign,nonatomic) NSString *displayedWord;
@property (assign,nonatomic) NSString *displayedMessage;

- (void) startSession;
- (void) clearSession;
- (void) sendString: (NSString *) string;

- (void) presentWaitingForConnexionScreen;
- (void) presentWaitingForWordToGuessScreen;
- (void) presentWordEnteringScreen;
- (void) presentWaitingForGuessScreen;
- (void) presentGuessingWordScreen;
- (void) presentNewGameScreenWithButton:(BOOL)withButton;

- (void) setImageNumber:(NSNumber *) imageNumber;

@end
